package com.reviewanalysisweb.converter;

import com.mongodb.BasicDBObjectBuilder;
import com.mongodb.DBObject;
import com.reviewanalysisweb.model.MappedInformation;
import org.bson.types.ObjectId;

/**
 *
 * @author monicaribeiro
 */

public class MappedInformationConverter 
{
    // convert Person Object to MongoDB DBObject
    // take special note of converting id String to ObjectId
    public static DBObject toDBObject (MappedInformation m) 
    {
        BasicDBObjectBuilder builder = BasicDBObjectBuilder.start()
                .append("_id", m.getId()).append("value", m.getCount());
        if (m.getId()!= null)
            builder = builder.append("_id", new ObjectId(m.getId()));
            return builder.get();
    }
    
    // convert DBObject Object to Person
    // take special note of converting ObjectId to String
    public static MappedInformation toMappedInformation (DBObject doc) 
    {
	MappedInformation m = new MappedInformation();
        m.setId((String) doc.get("_id"));
        m.setCount((double) doc.get("value"));
	return m;
    }
    
}
