package com.reviewanalysisweb.converter;

import com.mongodb.BasicDBObjectBuilder;
import com.mongodb.DBObject;
import com.reviewanalysisweb.model.Meta;
import org.bson.types.ObjectId;

/**
 *
 * @author monicaribeiro
 */
public class MetaConverter 
{
    // convert Person Object to MongoDB DBObject
    // take special note of converting id String to ObjectId
    public static DBObject toDBObject (Meta m) 
    {
        BasicDBObjectBuilder builder = BasicDBObjectBuilder.start()
                .append("_id", m.getId()).append("username", m.getUsername()).append("reviewId", m.getReviewId()).append("userId", m.getUserId())
                .append("appId", m.getAppId()).append("date", m.getDate()).append("unixTimeStamp", m.getUnixTimeStamp())
                .append("appVersion", m.getAppVersion()).append("numberOfHelpful", m.getNumberOfHelpful()).append("stars", m.getStars())
                .append("totalVotes", m.getTotalVotes());
        if (m.getId() != null)
            builder = builder.append("_id", new ObjectId(m.getId()));
            return builder.get();
    }
    
    // convert DBObject Object to Person
    // take special note of converting ObjectId to String
    public static Meta toMeta (DBObject doc) 
    {
	Meta m = new Meta();
        
        ObjectId id = (ObjectId) doc.get("_id");
        m.setId(id.toString());

        m.setDate((String) doc.get("date"));
        m.setUnixTimeStamp((String) doc.get("unixTimeStamp"));
        m.setUsername((String) doc.get("username"));
       
        m.setAppVersion((String) doc.get("appVersion"));
        m.setAppId((String) doc.get("appId"));
        m.setNumberOfHelpful((String) doc.get("numberOfHelpful"));
        m.setReviewId((String) doc.get("reviewId"));
        m.setStars((String) doc.get("stars"));
        m.setTotalVotes((String) doc.get("totalVotes"));
        m.setUserId((String) doc.get("userId;"));
        
	return m;
	}
    
}

