/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.reviewanalysisweb.converter;

import com.mongodb.BasicDBObjectBuilder;
import com.mongodb.DBObject;
import com.reviewanalysisweb.model.Review;
import org.bson.types.ObjectId;

/**
 *
 * @author monicaribeiro
 */
public class ReviewConverter 
{
    // convert Person Object to MongoDB DBObject
    // take special note of converting id String to ObjectId
    public static DBObject toDBObject(Review r) 
    {
	BasicDBObjectBuilder builder = BasicDBObjectBuilder.start()
		.append("content", r.getContent()).append("title", r.getTitle()).append("reviewId", r.getReviewId())
                .append("appId", r.getAppId());
        
	if (r.getId() != null)
            builder = builder.append("_id", new ObjectId(r.getId()));
            return builder.get();
        
    }

    // convert DBObject Object to Person
	// take special note of converting ObjectId to String
    public static Review toReview(DBObject doc) 
    {
	Review r = new Review();
        
        ObjectId id = (ObjectId) doc.get("_id");
        r.setId(id.toString());
        
        r.setAppId((String) doc.get("appId"));
        r.setContent((String) doc.get("content"));
        r.setReviewId((String) doc.get("reviewId"));
        r.setTitle((String) doc.get("title"));
        
	return r;
    }
}
