package com.reviewanalysisweb.dao;

import com.mongodb.BasicDBObject;
import com.mongodb.DBCollection;
import com.mongodb.DBCursor;
import com.mongodb.DBObject;
import com.mongodb.MongoClient;
import com.reviewanalysisweb.converter.MappedInformationConverter;
import com.reviewanalysisweb.converter.MetaConverter;
import com.reviewanalysisweb.model.MappedInformation;
import com.reviewanalysisweb.model.Meta;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author monicaribeiro
 */
public class MongoDBMappedProductDAO 
{
    
    private DBCollection col;
 
    public MongoDBMappedProductDAO(MongoClient mongo) 
    {
        this.col = mongo.getDB("reviewanalysis").getCollection("mapped_products");
    }
    
    public List<MappedInformation> readAllMappedProducts()
    {
        List<MappedInformation> data = new ArrayList<MappedInformation>();
        DBCursor cursor = col.find();
        cursor.sort(new BasicDBObject("value", -1));
        
        int contador = 10;
        while (contador >= 0)
        {
            DBObject doc = cursor.next();
            MappedInformation m = MappedInformationConverter.toMappedInformation(doc);
            data.add(m);
            contador = contador - 1;
        }
        
        return data;
    }
}
