package com.reviewanalysisweb.dao;

import com.mongodb.BasicDBObject;
import com.mongodb.BasicDBObjectBuilder;
import com.mongodb.DBCollection;
import com.mongodb.DBCursor;
import com.mongodb.DBObject;
import com.mongodb.MongoClient;
import com.reviewanalysisweb.converter.ReviewConverter;
import com.reviewanalysisweb.model.Review;
import java.util.ArrayList;
import java.util.List;
import org.bson.types.ObjectId;

/**
 *
 * @author monicaribeiro
 */
public class MongoDBReviewDAO 
{
    private DBCollection col;
    private DBCollection collection;
 
    public MongoDBReviewDAO(MongoClient mongo) 
    {
        this.col = mongo.getDB("reviewanalysis").getCollection("reviews");
        this.collection = mongo.getDB("reviewanalysis").getCollection("reviews");
    }
 
    public void updateReview(Review r) 
    {
        DBObject query = BasicDBObjectBuilder.start()
                .append("_id", new ObjectId(r.getId())).get();
        this.col.update(query, ReviewConverter.toDBObject(r));
    }
 
    public List<Review> readAllReview() 
    {
        List<Review> data = new ArrayList<Review>();
        DBCursor cursor = col.find();
       /* while (cursor.hasNext()) 
        {
            DBObject doc = cursor.next();
            Review r = ReviewConverter.toReview(doc);
            data.add(r);
        }*/
        int contador = 10;
        while (contador >= 0)
        {
            DBObject doc = cursor.next();
            Review r = ReviewConverter.toReview(doc);
            data.add(r);
            contador = contador - 1;
        }
        return data;
    }
 
    public List<Review> readAllReviews() 
    {
        List<Review> data = new ArrayList<Review>();
        DBCursor cursor = col.find();
        while (cursor.hasNext()) 
        {
            DBObject doc = cursor.next();
            Review r = ReviewConverter.toReview(doc);
            data.add(r);
        }
        return data;
    }
    
    public Review readReview(Review r) 
    {
        DBObject query = BasicDBObjectBuilder.start()
                .append("_id", new ObjectId(r.getId())).get();
        DBObject data = this.col.findOne(query);
        return ReviewConverter.toReview(data);
    }
    
    public List<Review> readSpecificReview(List<String> reviewsId)
    {
        
        List<Review> dataReview = new ArrayList<>();
        
        for( int i = 0; i < reviewsId.size(); i++)
        {
            DBCursor cursor = collection.find(new BasicDBObject("reviewId", reviewsId.get(i)));
            while(cursor.hasNext())
            {
                DBObject document = cursor.next();
                Review r = ReviewConverter.toReview(document);
                dataReview.add(r);
            }
        }
        return dataReview;
    }
    
    public Review readOneSpecificReview(String reviewsId) {
        DBCursor cursor = collection.find(new BasicDBObject("reviewId", reviewsId));
        DBObject document = cursor.next();
        Review r = ReviewConverter.toReview(document);
        return r ;
    }
    
}
