package com.reviewanalysisweb.factory;

import com.reviewanalysisweb.dao.MongoDBMetaDAO;
import com.reviewanalysisweb.dao.MongoDBReviewDAO;
import com.reviewanalysisweb.model.Meta;
import com.reviewanalysisweb.model.Review;
import com.reviewanalysisweb.service.ReviewSearchService;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author monicaribeiro
 */
public class SearchLimitedReviews implements ReviewSearchInterface {

    @Override
    public List<Meta> search(HttpServletRequest request, 
            HttpServletResponse response,
            MongoDBMetaDAO metaDao, 
            MongoDBReviewDAO reviewDao,
            String searchParameter) {
        
        List<Meta> metas = metaDao.readLimitedReviews();
        List<Review> reviews = reviewDao.readAllReviews();
        
        metas = ReviewSearchService.addReviewAttributesToMeta(metas, reviews);
        
        return metas;
    }
    
}
