/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.reviewanalysisweb.factory;

import com.mongodb.MongoClient;
import com.reviewanalysisweb.dao.MongoDBMetaDAO;
import com.reviewanalysisweb.dao.MongoDBReviewDAO;
import com.reviewanalysisweb.model.Meta;
import com.reviewanalysisweb.model.Review;
import com.reviewanalysisweb.service.ReviewSearchService;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author Gabriel
 */
public class SearchListOfReviews implements ReviewSearchInterface {

    private String atribute;
    
    private String parameter;
    
    @Override
    public List<Meta> search(HttpServletRequest request, 
            HttpServletResponse response,
            MongoDBMetaDAO metaDao, 
            MongoDBReviewDAO reviewDao,
            String searchParameter) {
        
        String userParameterSelected = request.getParameter("userRankingValue");
        String productParameterSelected = request.getParameter("productRankingValue");
        String reviewParameterSelected = request.getParameter("reviewRankingValue");
        
        List<Meta> metas = new ArrayList<Meta>();
        
        if(userParameterSelected != null) 
        {
            atribute = "username";
            parameter = userParameterSelected;
            metas = searchForReviews(metaDao, parameter, reviewDao, request, response, atribute);
        }
        
        if(productParameterSelected != null) 
        {
            atribute = "appId";
            parameter = productParameterSelected;
            metas = searchForReviews(metaDao, parameter, reviewDao, request, response, atribute);
        }
        
        if(reviewParameterSelected != null) 
        {
            atribute = "reviewId";
            parameter = reviewParameterSelected;
            metas = searchForReviews(metaDao, parameter, reviewDao, request, response, atribute);
        }
        
        return metas;
    }
    
    protected List<Meta> searchForReviews(
            MongoDBMetaDAO metaDAO, 
            String parameterSelected, 
            MongoDBReviewDAO reviewDAO, 
            HttpServletRequest request,
            HttpServletResponse response, 
            String atribute) {
        
        List<Meta> metas = metaDAO.readSpecificReview(atribute, parameterSelected);
        List<String> reviewsId = metaDAO.getReviewsId(atribute, parameterSelected);
        List<Review> reviews = reviewDAO.readSpecificReview(reviewsId);
        
        metas = ReviewSearchService.addReviewAttributesToMeta(metas, reviews);
        
        return metas;
    }
    
}
