package com.reviewanalysisweb.service;

import java.util.ArrayList;
import java.util.List;


public class HammingDistanceService {

    private String compOne;
    private String compTwo;

    public HammingDistanceService(String one, String two) {
        compOne = one;
        compTwo = two;
    }

    public int getHammingDistance(String compOne, String compTwo) {
        if (compOne.length() != compTwo.length()) {
            return -1;
        }

        int counter = 0;

        for (int i = 0; i < compOne.length(); i++) {
            if (compOne.charAt(i) != compTwo.charAt(i)) {
                counter++;
            }
        }

        return counter;
    }
    
    public float getSimilarityPercentage(String text1, String text2) {
        
        String array1[] = text1.split(" ");
        String array2[] = text2.split(" ");
        
        int numberOfEqualStrings = 0;
        List<Integer> indexesVisited = new ArrayList<Integer>();
        float similarityPercentage = 0;
        
        for (int i = 0; i < array1.length; i++) {
            
            for (int j = 0; j < array2.length; j++) {
                int hammingDistance = getHammingDistance(array1[i], array2[j]);
                
                if (!jNotInIndexesVisited(j, indexesVisited) && hammingDistance == 0) {
                    
                    numberOfEqualStrings++;
                    indexesVisited.add(j);
                }
            }
        }
        similarityPercentage = (numberOfEqualStrings * 100) / array2.length;
        return similarityPercentage;
    }

    
    private boolean jNotInIndexesVisited(int j, List<Integer>indexesVisited) {
        
        if (indexesVisited != null) {
            
            for (int h : indexesVisited) {
                if (j == h) {
                    return true;
                }
            }
        }
        return false;
        
    }
}


