package com.reviewanalysisweb.service;

import com.mongodb.MongoClient;
import com.reviewanalysisweb.dao.MongoDBMappedProductDAO;
import com.reviewanalysisweb.dao.MongoDBMappedUserDAO;
import com.reviewanalysisweb.model.MappedInformation;
import java.io.IOException;
import java.util.List;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author monicaribeiro
 */
public class MappedSearchService 
{
    public List<MappedInformation> searchAllMappedProducts(HttpServletRequest request, 
            HttpServletResponse response) 
            throws ServletException, IOException {
    
        MongoClient mongo = (MongoClient) request.getServletContext().getAttribute("MONGO_CLIENT");
                        
        MongoDBMappedProductDAO mappedProductDAO = new MongoDBMappedProductDAO(mongo);
        List<MappedInformation> mappedProducts = mappedProductDAO.readAllMappedProducts();
        return mappedProducts;
    }
    
    public List<MappedInformation> searchAllMappedUsers(HttpServletRequest request, 
            HttpServletResponse response) 
            throws ServletException, IOException {
    
        MongoClient mongo = (MongoClient) request.getServletContext().getAttribute("MONGO_CLIENT");
                        
        MongoDBMappedUserDAO mappedUserDAO = new MongoDBMappedUserDAO(mongo);
        List<MappedInformation> mappedUsers = mappedUserDAO.readAllMappedUsers();
        return mappedUsers;
    }
}
