/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.reviewanalysisweb.service;

import com.mongodb.MongoClient;
import com.reviewanalysisweb.dao.MongoDBMetaDAO;
import com.reviewanalysisweb.dao.MongoDBReviewDAO;
import com.reviewanalysisweb.factory.ReviewSearchFactory;
import com.reviewanalysisweb.factory.ReviewSearchInterface;
import com.reviewanalysisweb.model.Meta;
import com.reviewanalysisweb.model.Review;
import java.io.IOException;
import java.util.List;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author Gabriel
 */
public class ReviewSearchService {
    
    private String atribute;
    
    public List<Meta> searchListOfReviews(HttpServletRequest request, 
            HttpServletResponse response, String criteria, String searchParameter) 
            throws ServletException, IOException {
    
        MongoClient mongo = (MongoClient) request.getServletContext().getAttribute("MONGO_CLIENT");
                        
        MongoDBMetaDAO metaDAO = new MongoDBMetaDAO(mongo);
        MongoDBReviewDAO reviewDAO = new MongoDBReviewDAO(mongo);
        
        ReviewSearchInterface reviewSearch = ReviewSearchFactory.getReviewSearch(criteria);
        return reviewSearch.search(request, response, metaDAO, reviewDAO, searchParameter);
    }
    
    public List<Meta> searchOneReview (HttpServletRequest request, 
            HttpServletResponse response, String criteria) 
            throws ServletException, IOException {
    
        MongoClient mongo = (MongoClient) request.getServletContext().getAttribute("MONGO_CLIENT");
                        
        MongoDBMetaDAO metaDAO = new MongoDBMetaDAO(mongo);
        MongoDBReviewDAO reviewDAO = new MongoDBReviewDAO(mongo);
        
        ReviewSearchInterface reviewSearch = ReviewSearchFactory.getReviewSearch(criteria);
        List<Meta> metas = reviewSearch.search(request, response, metaDAO, reviewDAO, null);
        
        return metas;
      
    }
    
    /**
     * 
     */
    public static List<Meta> addReviewAttributesToMeta(List<Meta> metas, List<Review> reviews) {
        
        for (Review review : reviews) {
            
            for (Meta meta : metas) {
                
                if (review.getReviewId().equals(meta.getReviewId())) {
                    
                    meta.setTitle(review.getTitle());
                    meta.setContent(review.getContent());
                }
            }
        }
        
        return metas;
    }
}
