package com.reviewanalysisweb.servlets;

import com.reviewanalysisweb.model.Meta;
import com.reviewanalysisweb.model.Month;
import com.reviewanalysisweb.model.Year;
import com.reviewanalysisweb.service.ReviewSearchService;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author monicaribeiro
 */

@WebServlet("/ratingProduct")
public class RatingProductServlet extends HttpServlet
{
    private static final long serialVersionUID = -7060758261496829905L;
    
    private List<Year> listYears;
    
    private float productAverageRating;
    
    @Override
    protected void doPost(HttpServletRequest request,
        HttpServletResponse response) throws ServletException, IOException {
        
        ReviewSearchService reviewSearchService = new ReviewSearchService();
        request.setAttribute("reviewSelectedByUser", reviewSearchService.searchOneReview(request, response, "SPECIFICREVIEW")); 
        
        List<Meta> listProductMetas = new ArrayList<Meta>();
        listProductMetas = reviewSearchService.searchListOfReviews(request, response, "SPECIFICPARAMETER", "appId");
        
        listYears = new ArrayList<Year>();
        
        for(Meta meta : listProductMetas) {
            
            if(meta.getDate() != "")
            {
                String array[] = new String[3];
                array = meta.getDate().split(" ");
                
                if (!listYearsContains(array[2])) {
                    
                    Year year = new Year(array[2]);
                    // year.getListMonths().add(array[0]);
                    Month month = new Month(array[0], meta.getReviewId());
                    month.setRatingMonthly(Float.parseFloat(meta.getStars()));
                    year.getListMonths().add(month);
                    month.addRating(meta.getStars());
                    listYears.add(year);
                    
                } else {
                    for (Year year : listYears) {
                        if (year.getYear().equals(array[2])) {
                            
                            //for (Month month : year.getListMonths()) System.out.println(month.getMonth());
                                
                            if (!listMonthsContains(year.getListMonths(), array[0])) {
                                Month newMonth = new Month(array[0], meta.getReviewId());
                                newMonth.setRatingMonthly(newMonth.getRatingMonthly()+Float.parseFloat(meta.getStars()));
                                newMonth.calculateAverageRating();
                                newMonth.addRating(meta.getStars());
                                year.getListMonths().add(newMonth);
                                
                            } else {

                                for (Month month : year.getListMonths()) {
                                    
                                    if (month.getMonth().equals(array[0])) {
                                        
                                        month.setNumberOfReviews(month.getNumberOfReviews()+1);
                                        month.setRatingMonthly(month.getRatingMonthly()+Float.parseFloat(meta.getStars()));
                                        month.calculateAverageRating();
                                        month.addRating(meta.getStars());
                                        month.getListReviewIds().add(meta.getReviewId());
                                    }
                                }

                            }
                            
                        }
                    }
                }
            }
        }
        
        productAverageRating = calculateAverageRating(listProductMetas);
        
        DecimalFormat df =  new DecimalFormat("0.00");
                
        request.setAttribute("listYearsMonths", listYears);
        request.setAttribute("metas", listProductMetas);
        request.setAttribute("productAverageRating", df.format(productAverageRating));
        
        RequestDispatcher rd = getServletContext().getRequestDispatcher("/ratingProduct.jsp");
        rd.forward(request, response);
    }
    
    private boolean listYearsContains(String year) {

        for (Year yearOnList : listYears) {
            if (yearOnList.getYear().equals(year)) {
                return true;
            }
        }
        return false;
    }
    
    private boolean listMonthsContains(List<Month> listMonths, String month) {

        for (Month monthOnList : listMonths) {
            if (monthOnList.getMonth().equals(month)) {
                return true;
            }
        }
        return false;
    }

    private float calculateAverageRating(List<Meta> listProductMetas) {

        float acum = 0;
        for (Meta meta : listProductMetas) {
            
            acum += Float.parseFloat(meta.getStars());
        }
        
        return acum / listProductMetas.size();
    }
    
}
