<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Review Analysis</title>
        
        <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.5.1/jquery.min.js"></script>
        <script src="js/jquery.tablesorter.min.js"></script>
        <script src="js/jquery.tablesorter.pager.js"></script>
        <script src="js/listOfReviews.js"></script>
        <link rel="stylesheet" href="css/stylesLayout.css">
        <link rel="stylesheet" href="css/custom.css" media="screen" />
        
        <script src="js/scriptDropMenu.js"></script>
        <script src="js/Chart.js"></script>
        
    </head>
    <body>
        <c:url value="/temporalBehaviorUser" var="temporalBehaviorUserURL"></c:url>
        <c:url value="/temporalBehaviorProduct" var="temporalBehaviorProductURL"></c:url>
        <c:url value="/ratingUser" var="ratingUserURL"></c:url>
        <c:url value="/ratingProduct" var="ratingProductURL"></c:url>
        <c:url value="/textUser" var="textUserURL"></c:url>
        <c:url value="/textProduct" var="textProductURL"></c:url>
        <c:url value="/textAll" var="textAllURL"></c:url>
        
        <div id='cssmenu'>
            <ul>
                <li><a href='index.jsp'>Home</a></li>
                <li class='has-sub'><a href='#'>Temporal Behavior</a>
                    <ul>
                        <li class='has-sub'>
                            <form id="formTempBehaviorUser" action='<c:out value="${temporalBehaviorUserURL}"></c:out>' method="post">
                                <input type="hidden" name="marcar[]" value="${requestScope.reviewId}">
                                <a href="#" onclick="formTempBehaviorUser.submit();"> User</a>
                            </form>
                        </li>
                        <li class='has-sub'>
                            <form id="formTempBehaviorProd" action='<c:out value="${temporalBehaviorProductURL}"></c:out>' method="post">
                                <input type="hidden" name="marcar[]" value="${requestScope.reviewId}">
                                <a href="#" onclick="formTempBehaviorProd.submit();"> Product</a>
                            </form>
                        </li>
                    </ul>
                </li>
                <li class='has-sub'><a href='#'>Ratings</a>
                    <ul>
                        <li class='has-sub'>
                            <form id="formRatingUser" action='<c:out value="${ratingUserURL}"></c:out>' method="post">
                                <input type="hidden" name="marcar[]" value="${requestScope.reviewId}">
                                <a href="#" onclick="formRatingUser.submit();"> User</a>
                            </form>
                        </li>
                        <li class='has-sub'>
                            <form id="formRatingProd" action='<c:out value="${ratingProductURL}"></c:out>' method="post">
                                <input type="hidden" name="marcar[]" value="${requestScope.reviewId}">
                                <a href="#" onclick="formRatingProd.submit();"> Product</a>
                            </form>
                        </li>
                    </ul>
                </li>
                <li>
                    <form id="formText" action='<c:out value="${textUserURL}"></c:out>' method="post">
                        <input type="hidden" name="marcar[]" value="${requestScope.reviewId}">
                        <a href="#" onclick="formText.submit();"> Text Analysis</a>
                    </form>
                </li>
                <li class='has-sub'><a href='#'>Comparisons</a>
                    <ul>
                        <li class='has-sub'><a href='#'>Product</a></li>
                        <li class='has-sub'><a href='#'>User</a></li>
                    </ul>
                </li>
            </ul>
        </div>