<%@ include file="layout.jsp" %>    
<h1>User Rating</h1>
</br>
        <p>Select a year to check the monthly average rating of the user:</p>
        </br>
<select id="selectYear">
    <c:forEach items="${requestScope.listYearsMonths}" var="list">
        <option value="<c:out value="${list.year}"></c:out>"><c:out value="${list.year}"></c:out></option> 
    </c:forEach>
</select>

<input type="submit" name="Submit" id="submitYearButton">

<div style="width:30%">
    <div>
        <canvas id="canvas"></canvas>
    </div>
</div>
</br>
        <p>Select the year and month to check the monthly rating distribution of the user:</p>
        </br>
<select id="selectMonth">
    <c:forEach items="${requestScope.listYearsMonths}" var="listMonth">
        <c:forEach items="${listMonth.listMonths}" var="months">
            <option value="<c:out value="${months.month}"></c:out> <c:out value="${listMonth.year}"></c:out>">
                <c:out value="${months.month}"></c:out>, <c:out value="${listMonth.year} "></c:out>
            </option> 
        </c:forEach>
    </c:forEach>
</select>

<input type="submit" name="Submit" id="submitMonthButton">

<div style="width:30%">
    <div>
        <canvas id="canvasPieChart"></canvas>
    </div>
</div>

<script>
    document.getElementById("submitYearButton").addEventListener("click", function () 
    {
        
        var data = [];
        <c:forEach items="${requestScope.listYearsMonths}" var="listMonth">
            var teste = [];
            <c:forEach items="${listMonth.listMonths}" var="months">
                teste.push({
                    month: '${months.month}',
                    average: '${months.averageRating}'
                });
            </c:forEach>
            data.push(teste);
        </c:forEach>

        Array.prototype.mapProperty = function (property) {
            return this.map(function (obj) {
                return obj[property];
            });
        };

        var element = document.getElementById("selectYear");
        var selectedYear = element.options[element.selectedIndex].value;
        var index = $('#selectYear option[value="' + selectedYear + '"]').index();
        var lineChartData = {
            labels: data[index].mapProperty('month'),
            datasets: [
                {
                    label: "User Rating",
                    fillColor: "rgba(220,220,220,0.2)",
                    strokeColor: "rgba(220,220,220,1)",
                    pointColor: "rgba(220,220,220,1)",
                    pointStrokeColor: "#fff",
                    pointHighlightFill: "#fff",
                    pointHighlightStroke: "rgba(220,220,220,1)",
                    data: data[index].mapProperty('average')
                },
            ]
        }
        if (window.myLine != null) {
            window.myLine.destroy();
        }
        // Get the context of the canvas element we want to select
        var ctx = document.getElementById("canvas").getContext("2d");
        window.myLine = new Chart(ctx).Line(lineChartData, {responsive: true});

    })
    
    
    document.getElementById("submitMonthButton").addEventListener("click", function () 
    {
        var data = [];
        <c:forEach items="${requestScope.listYearsMonths}" var="listMonth">
            var listYears = [];
            <c:forEach items="${listMonth.listMonths}" var="months">
                listYears.push({
                    year: '${listMonth.year}',
                    month: '${months.month}',
                    totalRatings1 : '${months.totalRatings1}',
                    totalRatings2 : '${months.totalRatings2}',
                    totalRatings3 : '${months.totalRatings3}',
                    totalRatings4 : '${months.totalRatings4}',
                    totalRatings5 : '${months.totalRatings5}'
                });
            </c:forEach>
            data.push(listYears);
        </c:forEach>
        
        Array.prototype.mapProperty = function (property) {
            return this.map(function (obj) {
                return obj[property];
            });
        };
        
        var elementYear = document.getElementById("selectYear");
        var selectedYear = elementYear.options[elementYear.selectedIndex].value;
        var indexYear = $('#selectYear option[value="' + selectedYear + '"]').index();
        
        
        var elementMonth = document.getElementById("selectMonth");
        var selectedMonth = elementMonth.options[elementMonth.selectedIndex].value;
        
        var partsOfStr = selectedMonth.split(' ');
        
        var indexMonth = $('#selectMonth option[value="' + selectedMonth + '"]').index();
        
        for (i = 0; i <= data.length; i++)
        {
            if(data[i][0].year === partsOfStr[1])
            {
               for (j = 0; j < data[i].length; j++)
                {
                    if (data[i][j].month === partsOfStr[0])
                    {
                        var ratings1 = data[i][j].totalRatings1;
                        var ratings2 = data[i][j].totalRatings2;
                        var ratings3 = data[i][j].totalRatings3;
                        var ratings4 = data[i][j].totalRatings4;
                        var ratings5 = data[i][j].totalRatings5;
                        var pieData = [
				{
					value: ratings1,
					color:"#F7464A",
					highlight: "#FF5A5E",
					label: "1 Star"
				},
				{
					value: ratings2,
					color: "#46BFBD",
					highlight: "#5AD3D1",
					label: "2 Stars"
				},
				{
					value: ratings3,
					color: "#FDB45C",
					highlight: "#FFC870",
					label: "3 Stars"
				},
				{
					value: ratings4,
					color: "#949FB1",
					highlight: "#A8B3C5",
					label: "4 Stars"
				},
				{
					value: ratings5,
					color: "#4D5360",
					highlight: "#616774",
					label: "5 Stars"
				}

			];
                        
                        if (window.myPie != null) {
                            window.myPie.destroy();
                        }
                        // Get the context of the canvas element we want to select
                        var ctx = document.getElementById("canvasPieChart").getContext("2d");
                        window.myPie = new Chart(ctx).Pie(pieData);
                    }
                }
            }
        }
    })

</script>

</body>
</html>