<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Review Analysis - List of Reviews</title>
        <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.5.1/jquery.min.js"></script>
        <script src="js/jquery.tablesorter.min.js"></script>
        <script src="js/jquery.tablesorter.pager.js"></script>
        <script src="js/listOfReviews.js"></script>
        <link rel="stylesheet" href="css/custom.css" media="screen" />
    </head>

    <body>
        
    <div id="all">
	<div id="content">
        <c:url value="/temporalBehaviorProduct" var="temporalBehaviorProductURL"></c:url>
        
        <h2>Here is the list of reviews for the user/product you selected.</h2>
            <h2>Please choose one to analyse:</h2>
            <form method="post" action="listOfReviews.jsp" id="formulario">
                <p>
                    <label for="pesquisar">Search</label>
                    <input type="text" id="pesquisar" name="pesquisar" size="30" />
                </p>
            </form>

            <form action='<c:out value="${temporalBehaviorProductURL}"></c:out>' method="POST">
                <table cellspacing="0" summary="List of Reviews">
                    <thead>
                        <tr>
                            <th></th>
                            <th></th> 
                            <th>ReviewID</th>
                            <th>AppID</th>
                            <th>UserName</th>
                            <th>Rating</th>
                            <th>Text</th>
                            <th>Date</th>
                            <th>Number of Helpful</th>
                            <th>Votes<th>
                        </tr>
                    </thead>

                    <tbody>
                    <c:if test="${not empty requestScope.metas}">

                        <c:forEach items="${requestScope.metas}" var="meta">
                            <tr>
                                <td></td>
                                <td><input type="radio" value="${meta.reviewId}" name="marcar[]"/> </td>
                                <td><c:out value="${meta.reviewId}"></c:out></td>
                                <td><c:out value="${meta.appId}"></c:out></td>
                                <td><c:out value="${meta.username}"></c:out></td>
                                <td><c:out value="${meta.stars}"></c:out></td>
                                <td><c:out value="${meta.content}"></c:out></td>
                                <td><c:out value="${meta.date}"></c:out></td>
                                <td><c:out value="${meta.numberOfHelpful}"></c:out></td>
                                <td><c:out value="${meta.totalVotes}"></c:out></td>
                            </tr>
                        </c:forEach>
                    </c:if>
                </tbody>
            </table>
            <input type="submit" name="Analyse" id="analyseButton">
        </form>

        <div id="pager" class="pager">
            <form>
                <span>
                    Show <select class="pagesize">
                        <option selected="selected"  value="10">10</option>
                        <option value="20">20</option>
                        <option value="30">30</option>
                        <option  value="40">40</option>
                    </select> reviews
                </span> 

                <img src="icons/first.png" class="first"/>
                <img src="icons/prev.png" class="prev"/>
                <input type="text" class="pagedisplay"/>
                <img src="icons/next.png" class="next"/>
                <img src="icons/last.png" class="last"/>
            </form>
        </div>
                
        </div>
    </div>
    
    
    <script>
        function truncateText(selector, maxLength) {
        var element = document.querySelector(selector),
            truncated = element.innerText;

        if (truncated.length > maxLength) {
            truncated = truncated.substr(0,maxLength) + '...';
        }
        return truncated;
    }

    document.querySelector('td').innerText = truncateText('td', 10);
        
    </script>
    </body>
</html>
