<%@ include file="layout.jsp" %>  

<h1>Product Temporal Behavior</h1>
<p>Select a year to see the number of reviews received over time:</p>

<select id="selectYear">

    <c:forEach items="${requestScope.listYearsMonths}" var="list">
        <option value="<c:out value="${list.year}"></c:out>"><c:out value="${list.year}"></c:out></option> 
    </c:forEach>
</select>
<input type="submit" name="Submit" id="submitYearButton">

<div style="width:30%">
    <div>
        <canvas id="canvas"></canvas>
    </div>
</div>
</br>
<p>Above is a list of reviews made by users about this product:</p>
</br>
<table cellspacing="0" summary="List of Reviews">
    <thead>
        <tr>
            <th>ReviewID</th>
            <th>AppId</th>
            <th>UserName</th>
            <th>Rating</th>
            <th>Text</th>
            <th>Date</th>
        </tr>
    </thead>

    <tbody>
    <c:if test="${not empty requestScope.metas}">

        <c:forEach items="${requestScope.metas}" var="meta">
            <tr>
                <td><c:out value="${meta.reviewId}"></c:out></td>
                <td><c:out value="${meta.appId}"></c:out></td>
                <td><c:out value="${meta.username}"></c:out></td>
                <td><c:out value="${meta.stars}"></c:out></td>
                <td><c:out value="${meta.content}"></c:out></td>
                <td><c:out value="${meta.date}"></c:out></td>
            </tr>
        </c:forEach>
    </c:if>
</tbody>
</table>
<div id="pager" class="pager">
<form>
    <span>
        Show <select class="pagesize">
            <option selected="selected"  value="10">10</option>
            <option value="20">20</option>
            <option value="30">30</option>
            <option  value="40">40</option>
        </select> reviews
    </span> 

    <img src="icons/first.png" class="first"/>
    <img src="icons/prev.png" class="prev"/>
    <input type="text" class="pagedisplay"/>
    <img src="icons/next.png" class="next"/>
    <img src="icons/last.png" class="last"/>
</form>
</div>

<script>
    document.getElementById("submitYearButton").addEventListener("click", function () {
        var data = [];
    <c:forEach items="${requestScope.listYearsMonths}" var="listMonth">
        var teste = [];
        <c:forEach items="${listMonth.listMonths}" var="months">
        teste.push({
            month: '${months.month}',
            number: '${months.numberOfReviews}'
        });
        </c:forEach>
        data.push(teste);
    </c:forEach>


        Array.prototype.mapProperty = function (property) {
            return this.map(function (obj) {
                return obj[property];
            });
        };

        var element = document.getElementById("selectYear");
        var selectedYear = element.options[element.selectedIndex].value;
        var index = $('#selectYear option[value="' + selectedYear + '"]').index();
        var lineChartData = {
            labels: data[index].mapProperty('month'),
            datasets: [
                {
                    label: "My First dataset",
                    fillColor: "rgba(220,220,220,0.2)",
                    strokeColor: "rgba(220,220,220,1)",
                    pointColor: "rgba(220,220,220,1)",
                    pointStrokeColor: "#fff",
                    pointHighlightFill: "#fff",
                    pointHighlightStroke: "rgba(220,220,220,1)",
                    data: data[index].mapProperty('number')
                },
            ]
        }

        if (window.myLine != null) {
            window.myLine.destroy();
        }
        // Get the context of the canvas element we want to select
        var ctx = document.getElementById("canvas").getContext("2d");
        window.myLine = new Chart(ctx).Line(lineChartData, {responsive: true});

    })

</script>
</body>
</html>
